// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::TabStyle;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlTabStrip")]
    pub struct TabStrip(Object<ffi::DzlTabStrip, ffi::DzlTabStripClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_tab_strip_get_type(),
    }
}

impl TabStrip {
    pub const NONE: Option<&'static TabStrip> = None;

    #[doc(alias = "dzl_tab_strip_new")]
    pub fn new() -> TabStrip {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_tab_strip_new()).unsafe_cast() }
    }
}

impl Default for TabStrip {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::TabStrip>> Sealed for T {}
}

pub trait TabStripExt: IsA<TabStrip> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_tab_strip_add_control")]
    fn add_control(&self, widget: &impl IsA<gtk::Widget>) {
        unsafe {
            ffi::dzl_tab_strip_add_control(
                self.as_ref().to_glib_none().0,
                widget.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_tab_strip_get_edge")]
    #[doc(alias = "get_edge")]
    fn edge(&self) -> gtk::PositionType {
        unsafe { from_glib(ffi::dzl_tab_strip_get_edge(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_strip_get_stack")]
    #[doc(alias = "get_stack")]
    fn stack(&self) -> Option<gtk::Stack> {
        unsafe { from_glib_none(ffi::dzl_tab_strip_get_stack(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_strip_get_style")]
    #[doc(alias = "get_style")]
    fn style(&self) -> TabStyle {
        unsafe { from_glib(ffi::dzl_tab_strip_get_style(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_strip_set_edge")]
    fn set_edge(&self, edge: gtk::PositionType) {
        unsafe {
            ffi::dzl_tab_strip_set_edge(self.as_ref().to_glib_none().0, edge.into_glib());
        }
    }

    #[doc(alias = "dzl_tab_strip_set_stack")]
    fn set_stack(&self, stack: &impl IsA<gtk::Stack>) {
        unsafe {
            ffi::dzl_tab_strip_set_stack(
                self.as_ref().to_glib_none().0,
                stack.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_tab_strip_set_style")]
    fn set_style(&self, style: TabStyle) {
        unsafe {
            ffi::dzl_tab_strip_set_style(self.as_ref().to_glib_none().0, style.into_glib());
        }
    }

    #[doc(alias = "edge")]
    fn connect_edge_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_edge_trampoline<P: IsA<TabStrip>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTabStrip,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TabStrip::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::edge\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_edge_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "stack")]
    fn connect_stack_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_stack_trampoline<P: IsA<TabStrip>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTabStrip,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TabStrip::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::stack\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_stack_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "style")]
    fn connect_style_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_style_trampoline<P: IsA<TabStrip>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTabStrip,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TabStrip::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::style\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_style_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<TabStrip>> TabStripExt for O {}

impl fmt::Display for TabStrip {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("TabStrip")
    }
}
